set BUILD_DIR=build
set CMAKE=cmake -Wno-dev -G "MinGW Makefiles"

set PG=-D NEED_PROFILE=0
set IUG=-D NEED_INLINE=0

for %%O in ( %* ) do (
    if "%%O" == "--release" (
        if not defined BUILD_TYPE set BUILD_TYPE=Release
        if "Debug" == "%BUILD_TYPE%" set BUILD_TYPE=RelWithDebInfo
    ) else if "%%O" == "--debug" (
        if not defined BUILD_TYPE set BUILD_TYPE=Debug
        if "Release" == "%BUILD_TYPE%" set BUILD_TYPE=RelWithDebInfo
    ) else if "%%O" == "--profile" (
        set PG=-D NEED_PROFILE=1
    ) else if "%%O" == "--inline" (
        set IUG=-D NEED_INLINE=1
    ) else (
        echo Invalid option: "%%O"
        goto :EOF
        )
    )

if not exist %BUILD_DIR% mkdir %BUILD_DIR%
cd %BUILD_DIR% || goto :EOF

if not exist CMakeCache.txt if not defined BUILD_TYPE set BUILD_TYPE=Release

if defined BUILD_TYPE set CBT=-D CMAKE_BUILD_TYPE=%BUILD_TYPE%

%CMAKE% %CBT% %PG% %IUG% ..
