@echo off

set CODEC=-pix_fmt yuvj420p -vcodec ljpeg
set FFPROBE=ffprobe
set FFMPEG=ffmpeg

if exist "%1" if not "" == "%2" goto ok
    echo Call: %0 input output [filters]
    goto :EOF
:ok

set FILE=%1
set OUT=%2

set VI3X=vi3x.exe
if exist %~dp0\vi3x.exe set VI3X=%~dp0\vi3x.exe
if exist .\vi3x.exe set VI3X=.\vi3x.exe

for /f "tokens=1,2 delims== " %%L in ('%FFPROBE% -show_streams "%FILE%"') do (
    if "codec_type" == "%%L" call :set_ct %%M
    if "[/STREAM]" == "%%L" call :set_ct ""
    if "width" == "%%L" call :set_width %%M
    if "height" == "%%L" call :set_height %%M
    if "r_frame_rate" == "%%L" call :set_rate %%M
    )
for /f "tokens=1,2 delims=/" %%L in ("%r_frame_rate%") do (
    set fps_in=%%L
    set fps_div_in=%%M
    )

for /f %%L in ('%VI3X% -i "420p:w=%width_in%,h=%height_in%,fps=%fps_in%,fps_div=%fps_div_in%" -o "null" -t %3 %4 %5 %6 %7 %8 %9') do (
    set %%L
    )

if "" == "%WIDTH%" goto :EOF
if "" == "%HEIGHT%" goto :EOF

if exist "%OUT%" del "%OUT%"

%FFMPEG% -i "%FILE%" -an -f rawvideo -vcodec rawvideo pipe: | %VI3X% -i "420p:w=%width_in%,h=%height_in%,fps=%fps_in%,fps_div=%fps_div_in%" -o "420p" %3 %4 %5 %6 %7 %8 %9 | %FFMPEG% -f rawvideo -pix_fmt yuv420p -s "%WIDTH%x%HEIGHT%" -r "%FPS%/%FPS_DIV%" -i pipe: %CODEC% "%OUT%"
goto :EOF

:set_ct
set codec_type=%1
goto :EOF

:set_width
if "video" == "%codec_type%" set width_in=%1
goto :EOF

:set_height
if "video" == "%codec_type%" set height_in=%1
goto :EOF

:set_rate
if "video" == "%codec_type%" set r_frame_rate=%1
goto :EOF

