@echo off

set FFPROBE=ffprobe
set FFMPEG=ffmpeg
set FFPLAY=ffplay
set SZ_KEY=-video_size

if not exist "%1" (
    echo Call: %0 file_name [filters]
    goto :EOF
    )

set FILE=%1

set VI3X=vi3x.exe
if exist %~dp0\vi3x.exe set VI3X=%~dp0\vi3x.exe
if exist .\vi3x.exe set VI3X=.\vi3x.exe

for /f "tokens=1,2 delims== " %%L in ('%FFPROBE% -show_streams "%FILE%"') do (
    if "codec_type" == "%%L" call :set_ct %%M
    if "[/STREAM]" == "%%L" call :set_ct ""
    if "width" == "%%L" call :set_width %%M
    if "height" == "%%L" call :set_height %%M
    if "r_frame_rate" == "%%L" call :set_rate %%M
    )
for /f "tokens=1,2 delims=/" %%L in ("%r_frame_rate%") do (
    set fps_in=%%L
    set fps_div_in=%%M
    )

for /f %%L in ('%VI3X% -i "420p:w=%width_in%,h=%height_in%,fps=%fps_in%,fps_div=%fps_div_in%" -o "null" -t %2 %3 %4 %5 %6 %7 %8 %9') do (
    set %%L
    )

if "" == "%WIDTH%" goto :EOF
if "" == "%HEIGHT%" goto :EOF

for /f "tokens=1,2,3 delims=. " %%L in ('%FFPLAY% -version') do (
    if /i "ffplay" == "%%L" if "0" == "%%M" if "%%N" LEQ "6" set SZ_KEY=-s
    )

%FFMPEG% -i "%FILE%" -an -f rawvideo -vcodec rawvideo pipe: | %VI3X% -i "420p:w=%width_in%,h=%height_in%,fps=%fps_in%,fps_div=%fps_div_in%" -o "420p" %2 %3 %4 %5 %6 %7 %8 %9 | %FFPLAY% -f rawvideo %SZ_KEY% "%WIDTH%x%HEIGHT%" -pix_fmt yuv420p pipe:
goto :EOF

:set_ct
set codec_type=%1
goto :EOF

:set_width
if "video" == "%codec_type%" set width_in=%1
goto :EOF

:set_height
if "video" == "%codec_type%" set height_in=%1
goto :EOF

:set_rate
if "video" == "%codec_type%" set r_frame_rate=%1
goto :EOF

