#ifndef _VI3X_MODULES_H_
#define _VI3X_MODULES_H_

#include "vi3x_types.h"

#define VI3X_NAME_SZ 32

#ifndef VI3X_MAIN_NAME
#define VI3X_MAIN() static __attribute__((constructor)) void vi3x_module_main(void)
#else
#define VI3X_MAIN() void VI3X_MAIN_NAME(void)
#endif /* VI3X_MAIN_NAME */

void vi3x_register_modules(void);
void vi3x_reg_import(
    char const *m_name, vi3x_module_f *m_init, vi3x_help_f *m_help);
void vi3x_reg_export(
    char const *m_name, vi3x_module_f *m_init, vi3x_help_f *m_help);
void vi3x_reg_filter(
    char const *m_name, vi3x_module_f *m_init, vi3x_help_f *m_help);
vi3x_module_t *vi3x_create_import(char const *m_name);
vi3x_module_t *vi3x_create_export(char const *m_name);
vi3x_module_t *vi3x_create_filter(char const *m_name);
void vi3x_free_module(vi3x_module_t *m);
int vi3x_is_import(vi3x_module_t const *m);
int vi3x_is_export(vi3x_module_t const *m);
void vi3x_help_import(char const *m_name);
void vi3x_help_export(char const *m_name);
void vi3x_help_filter(char const *m_name);
void vi3x_help_all_import(int help_short);
void vi3x_help_all_export(int help_short);
void vi3x_help_all_filter(int help_short);

#endif /* _VI3X_MODULES_H_ */
